;'use strict';this.asyncStorage=(function(){var DBNAME='asyncStorage';var DBVERSION=1;var STORENAME='keyvaluepairs';var db=null;function withStore(type,f){if(db){f(db.transaction(STORENAME,type).objectStore(STORENAME));}else{var openreq=indexedDB.open(DBNAME,DBVERSION);openreq.onerror=function withStoreOnError(){console.error("asyncStorage: can't open database:",openreq.error.name);};openreq.onupgradeneeded=function withStoreOnUpgradeNeeded(){openreq.result.createObjectStore(STORENAME);};openreq.onsuccess=function withStoreOnSuccess(){db=openreq.result;f(db.transaction(STORENAME,type).objectStore(STORENAME));};}}
function getItem(key,callback){withStore('readonly',function getItemBody(store){var req=store.get(key);req.onsuccess=function getItemOnSuccess(){var value=req.result;if(value===undefined)
value=null;callback(value);};req.onerror=function getItemOnError(){console.error('Error in asyncStorage.getItem(): ',req.error.name);};});}
function setItem(key,value,callback){withStore('readwrite',function setItemBody(store){var req=store.put(value,key);if(callback){req.onsuccess=function setItemOnSuccess(){callback();};}
req.onerror=function setItemOnError(){console.error('Error in asyncStorage.setItem(): ',req.error.name);};});}
function removeItem(key,callback){withStore('readwrite',function removeItemBody(store){var req=store.delete(key);if(callback){req.onsuccess=function removeItemOnSuccess(){callback();};}
req.onerror=function removeItemOnError(){console.error('Error in asyncStorage.removeItem(): ',req.error.name);};});}
function clear(callback){withStore('readwrite',function clearBody(store){var req=store.clear();if(callback){req.onsuccess=function clearOnSuccess(){callback();};}
req.onerror=function clearOnError(){console.error('Error in asyncStorage.clear(): ',req.error.name);};});}
function length(callback){withStore('readonly',function lengthBody(store){var req=store.count();req.onsuccess=function lengthOnSuccess(){callback(req.result);};req.onerror=function lengthOnError(){console.error('Error in asyncStorage.length(): ',req.error.name);};});}
function key(n,callback){if(n<0){callback(null);return;}
withStore('readonly',function keyBody(store){var advanced=false;var req=store.openCursor();req.onsuccess=function keyOnSuccess(){var cursor=req.result;if(!cursor){callback(null);return;}
if(n===0){callback(cursor.key);}else{if(!advanced){advanced=true;cursor.advance(n);}else{callback(cursor.key);}}};req.onerror=function keyOnError(){console.error('Error in asyncStorage.key(): ',req.error.name);};});}
return{getItem:getItem,setItem:setItem,removeItem:removeItem,clear:clear,length:length,key:key};}());;'use strict';(function(window){var gL10nData={};var gTextProp='textContent';var gLanguage='';var gMacros={};var gReadyState='loading';var gAsyncResourceLoading=true;var gDEBUG=1;function consoleLog(message){if(gDEBUG>=2){console.log('[l10n] '+message);}};function consoleWarn(message){if(gDEBUG){console.warn('[l10n] '+message);}};function getL10nResourceLinks(){return document.querySelectorAll('link[type="application/l10n"]');}
function getL10nDictionary(){var script=document.querySelector('script[type="application/l10n"]');return script?JSON.parse(script.innerHTML):null;}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function getL10nAttributes(element){if(!element)
return{};var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args={};if(l10nArgs){try{args=JSON.parse(l10nArgs);}catch(e){consoleWarn('could not parse arguments for #'+l10nId);}}
return{id:l10nId,args:args};}
function fireL10nReadyEvent(){var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=gLanguage;window.dispatchEvent(evtObject);}
function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/\/[^\/]*$/,'/');function evalString(text){if(text.lastIndexOf('\\')<0)
return text;return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text){var dictionary=[];var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax){var entries=rawText.replace(reBlank,'').split(/[\r\n]+/);var currentLang='*';var genericLang=lang.replace(/-[a-z]+$/i,'');var skipLang=false;var match='';for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(extendedSyntax){if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=='*')&&(currentLang!==lang)&&(currentLang!==genericLang);continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);loadImport(baseURL+match[1]);}}
var tmp=line.match(reSplit);if(tmp&&tmp.length==3){dictionary[tmp[1]]=evalString(tmp[2]);}}}
function loadImport(url){loadResource(url,function(content){parseRawLines(content,false);},null,false);}
parseRawLines(text,true);return dictionary;}
function loadResource(url,onSuccess,onFailure,asynchronous){onSuccess=onSuccess||function _onSuccess(data){};onFailure=onFailure||function _onFailure(){consoleWarn(url+' not found.');};var xhr=new XMLHttpRequest();xhr.open('GET',url,asynchronous);if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain; charset=utf-8');}
xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status===0){onSuccess(xhr.responseText);}else{onFailure();}}};xhr.onerror=onFailure;xhr.ontimeout=onFailure;try{xhr.send(null);}catch(e){onFailure();}}
loadResource(href,function(response){var data=parseProperties(response);for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop=gTextProp;}
if(!gL10nData[id]){gL10nData[id]={};}
gL10nData[id][prop]=data[key];}
if(successCallback){successCallback();}},failureCallback,gAsyncResourceLoading);};function loadLocale(lang,callback){callback=callback||function _callback(){};clear();gLanguage=lang;var langLinks=getL10nResourceLinks();var langCount=langLinks.length;if(langCount==0){var dict=getL10nDictionary();if(dict&&dict.locales&&dict.default_locale){consoleLog('using the embedded JSON directory, early way out');gL10nData=dict.locales[lang]||dict.locales[dict.default_locale];callback();}else{consoleLog('no resource to load, early way out');}
fireL10nReadyEvent(lang);gReadyState='complete';return;}
var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){callback();fireL10nReadyEvent(lang);gReadyState='complete';}};function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;parseResource(href,lang,callback,function(){consoleWarn(href+' not found.');applied='';});return applied;};}
for(var i=0;i<langCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang){consoleWarn('"'+lang+'" resource not found');gLanguage='';}}}
function clear(){gL10nData={};gLanguage='';}
function getPluralRules(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return start<=n&&n<=end;}
var pluralRules={'0':function(n){return'other';},'1':function(n){if((isBetween((n%100),3,10)))
return'few';if(n===0)
return'zero';if((isBetween((n%100),11,99)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'2':function(n){if(n!==0&&(n%10)===0)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'3':function(n){if(n==1)
return'one';return'other';},'4':function(n){if((isBetween(n,0,1)))
return'one';return'other';},'5':function(n){if((isBetween(n,0,2))&&n!=2)
return'one';return'other';},'6':function(n){if(n===0)
return'zero';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'7':function(n){if(n==2)
return'two';if(n==1)
return'one';return'other';},'8':function(n){if((isBetween(n,3,6)))
return'few';if((isBetween(n,7,10)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'9':function(n){if(n===0||n!=1&&(isBetween((n%100),1,19)))
return'few';if(n==1)
return'one';return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19)))
return'few';if((n%10)==1&&!(isBetween((n%100),11,19)))
return'one';return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14)))
return'many';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'12':function(n){if((isBetween(n,2,4)))
return'few';if(n==1)
return'one';return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if(n!=1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14)))
return'many';if(n==1)
return'one';return'other';},'14':function(n){if((isBetween((n%100),3,4)))
return'few';if((n%100)==2)
return'two';if((n%100)==1)
return'one';return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10)))
return'few';if((isBetween((n%100),11,19)))
return'many';if(n==1)
return'one';return'other';},'16':function(n){if((n%10)==1&&n!=11)
return'one';return'other';},'17':function(n){if(n==3)
return'few';if(n===0)
return'zero';if(n==6)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'18':function(n){if(n===0)
return'zero';if((isBetween(n,0,2))&&n!==0&&n!=2)
return'one';return'other';},'19':function(n){if((isBetween(n,2,10)))
return'few';if((isBetween(n,0,1)))
return'one';return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)==9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99)))
return'few';if((n%1000000)===0&&n!==0)
return'many';if((n%10)==2&&!isIn((n%100),[12,72,92]))
return'two';if((n%10)==1&&!isIn((n%100),[11,71,91]))
return'one';return'other';},'21':function(n){if(n===0)
return'zero';if(n==1)
return'one';return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99)))
return'one';return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0)
return'one';return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19)))
return'few';if(isIn(n,[2,12]))
return'two';if(isIn(n,[1,11]))
return'one';return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){consoleWarn('plural form unknown for ['+lang+']');return function(){return'other';};}
return pluralRules[index];}
gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))
return str;if(prop!=gTextProp)
return str;if(!gMacros._pluralRules){gMacros._pluralRules=getPluralRules(gLanguage);}
var index='['+gMacros._pluralRules(n)+']';if(n===0&&(key+'[zero]')in gL10nData){str=gL10nData[key+'[zero]'][prop];}else if(n==1&&(key+'[one]')in gL10nData){str=gL10nData[key+'[one]'][prop];}else if(n==2&&(key+'[two]')in gL10nData){str=gL10nData[key+'[two]'][prop];}else if((key+index)in gL10nData){str=gL10nData[key+index][prop];}else if((key+'[other]')in gL10nData){str=gL10nData[key+'[other]'][prop];}
return str;};function getL10nData(key,args){var data=gL10nData[key];if(!data){consoleWarn('#'+key+' is undefined.');}
var rv={};for(var prop in data){var str=data[prop];str=substIndexes(str,args,key,prop);str=substArguments(str,args,key);rv[prop]=str;}
return rv;}
function substIndexes(str,args,key,prop){var reIndex=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;var reMatch=reIndex.exec(str);if(!reMatch||!reMatch.length)
return str;var macroName=reMatch[1];var paramName=reMatch[2];var param;if(args&&paramName in args){param=args[paramName];}else if(paramName in gL10nData){param=gL10nData[paramName];}
if(macroName in gMacros){var macro=gMacros[macroName];str=macro(str,param,key,prop);}
return str;}
function substArguments(str,args,key){var reArgs=/\{\{\s*(.+?)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(args&&arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg][gTextProp];}else{consoleLog('argument {{'+arg+'}} for #'+key+' is undefined.');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var data=getL10nData(l10n.id,l10n.args);if(!data){consoleWarn('#'+l10n.id+' is undefined.');return;}
if(data[gTextProp]){if(element.children.length===0){element[gTextProp]=data[gTextProp];}else{var children=element.childNodes;var found=false;for(var i=0,l=children.length;i<l;i++){if(children[i].nodeType===3&&/\S/.test(children[i].nodeValue)){if(found){children[i].nodeValue='';}else{children[i].nodeValue=data[gTextProp];found=true;}}}
if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild);}}
delete data[gTextProp];}
for(var k in data){element[k]=data[k];}}
function translateFragment(element){element=element||document.documentElement;var children=getTranslatableChildren(element);var elementCount=children.length;for(var i=0;i<elementCount;i++){translateElement(children[i]);}
translateElement(element);}
function l10nStartup(){gReadyState='interactive';consoleLog('loading ['+navigator.language+'] resources, '+
(gAsyncResourceLoading?'asynchronously.':'synchronously.'));if(document.documentElement.lang===navigator.language){loadLocale(navigator.language);}else{loadLocale(navigator.language,translateFragment);}}
if(typeof(document)!=='undefined'){if(document.readyState==='complete'||document.readyState==='interactive'){window.setTimeout(l10nStartup);}else{document.addEventListener('DOMContentLoaded',l10nStartup);}}
if('mozSettings'in navigator&&navigator.mozSettings){navigator.mozSettings.addObserver('language.current',function(event){loadLocale(event.settingValue,translateFragment);});}
navigator.mozL10n={get:function l10n_get(key,args,fallback){var data=getL10nData(key,args)||fallback;if(data){return'textContent'in data?data.textContent:'';}
return'{{'+key+'}}';},get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};},translate:translateFragment,get dictionary(){return JSON.parse(JSON.stringify(gL10nData));},get readyState(){return gReadyState;},ready:function l10n_ready(callback){if(!callback){return;}else if(gReadyState=='complete'||gReadyState=='interactive'){window.setTimeout(callback);}else{window.addEventListener('localized',callback);}}};consoleLog('library loaded.');})(this);;'use strict';navigator.mozL10n.DateTimeFormat=function(locales,options){var _=navigator.mozL10n.get;function localeFormat(d,format){var tokens=format.match(/(%E.|%O.|%.)/g);for(var i=0;tokens&&i<tokens.length;i++){var value='';switch(tokens[i]){case'%a':value=_('weekday-'+d.getDay()+'-short');break;case'%A':value=_('weekday-'+d.getDay()+'-long');break;case'%b':case'%h':value=_('month-'+d.getMonth()+'-short');break;case'%B':value=_('month-'+d.getMonth()+'-long');break;case'%I':value=d.getHours()%12||12;break;case'%e':value=d.getDate();break;case'%c':case'%x':case'%X':var tmp=_('dateTimeFormat_'+tokens[i]);if(tmp&&!(/(%c|%x|%X)/).test(tmp)){value=localeFormat(d,tmp);}
break;}
format=format.replace(tokens[i],value||d.toLocaleFormat(tokens[i]));}
return format;}
function prettyDate(time,useCompactFormat){switch(time.constructor){case String:time=parseInt(time);break;case Date:time=time.getTime();break;}
var secDiff=(Date.now()-time)/1000;if(isNaN(secDiff)){return _('incorrectDate');}
var f=useCompactFormat?'-short':'-long';if(secDiff>=0){var dayDiff=Math.floor(secDiff/86400);if(secDiff<3600){return _('minutesAgo'+f,{m:Math.floor(secDiff/60)});}else if(dayDiff===0){return _('hoursAgo'+f,{h:Math.floor(secDiff/3600)});}else if(dayDiff<10){return _('daysAgo'+f,{d:dayDiff});}}
if(secDiff<0){secDiff=-secDiff;dayDiff=Math.floor(secDiff/86400);if(secDiff<3600){return _('inMinutes'+f,{m:Math.floor(secDiff/60)});}else if(dayDiff===0){return _('inHours'+f,{h:Math.floor(secDiff/3600)});}else if(dayDiff<10){return _('inDays'+f,{d:dayDiff});}}
return localeFormat(new Date(time),'%x');}
return{localeDateString:function localeDateString(d){return localeFormat(d,'%x');},localeTimeString:function localeTimeString(d){return localeFormat(d,'%X');},localeString:function localeString(d){return localeFormat(d,'%c');},localeFormat:localeFormat,fromNow:prettyDate};};;'use strict';var CustomDialog=(function(){var screen=null;var dialog=null;var header=null;var message=null;var yes=null;var no=null;return{hide:function dialog_hide(){if(screen===null)
return;document.body.removeChild(screen);screen=null;dialog=null;header=null;message=null;yes=null;no=null;},show:function dialog_show(title,msg,cancel,confirm){if(screen===null){screen=document.createElement('section');screen.setAttribute('role','region');screen.id='dialog-screen';dialog=document.createElement('div');dialog.id='dialog-dialog';dialog.setAttribute('role','dialog');screen.appendChild(dialog);var info=document.createElement('div');info.className='inner';if(title&&title!=''){header=document.createElement('h3');header.id='dialog-title';header.textContent=title;info.appendChild(header);}
message=document.createElement('p');message.id='dialog-message';info.appendChild(message);dialog.appendChild(info);var menu=document.createElement('menu');menu.dataset['items']=1;no=document.createElement('button');var noText=document.createTextNode(cancel.title);no.appendChild(noText);no.id='dialog-no';no.addEventListener('click',clickHandler);menu.appendChild(no);if(confirm){menu.dataset['items']=2;yes=document.createElement('button');var yesText=document.createTextNode(confirm.title);yes.appendChild(yesText);yes.id='dialog-yes';yes.className='negative';yes.addEventListener('click',clickHandler);menu.appendChild(yes);}
dialog.appendChild(menu);document.body.appendChild(screen);}
message.textContent=msg;screen.classList.add('visible');function clickHandler(evt){screen.classList.remove('visible');if(evt.target===yes&&confirm.callback){confirm.callback();}else if(evt.target===no&&cancel.callback){cancel.callback();}}}};}());;'use strict';(function(window){var navigator=window.navigator;if('mozTelephony'in navigator)
return;var TelephonyCalls=[];if(typeof(RecentsDBManager)!='undefined'&&RecentsDBManager){RecentsDBManager.init(function(){RecentsDBManager.prepopulateDB(function(){RecentsDBManager.close();});});}
navigator.mozTelephony={dial:function(number){var TelephonyCall={number:number,state:'dialing',addEventListener:function(){},hangUp:function(){},removeEventListener:function(){}};TelephonyCalls.push(TelephonyCall);return TelephonyCall;},addEventListener:function(name,handler){},get calls(){return TelephonyCalls;},muted:false,speakerEnabled:false,onincoming:null,oncallschanged:null};})(this);(function(window){var supportedEvents={keydown:true,keyup:true};var listeners=[];var originalAddEventListener=window.addEventListener;window.addEventListener=function(type,listener,capture){if(this===window&&supportedEvents[type]){listeners.push({type:type,listener:listener,capture:capture});}
originalAddEventListener.call(this,type,listener,capture);};var originalRemoveEventListener=window.removeEventListener;window.removeEventListener=function(type,listener){if(this===window&&supportedEvents[type]){var newListeners=[];for(var n=0;n<listeners.length;++n){if(listeners[n].type==type&&listeners[n].listener==listener)
continue;newListeners.push(listeners[n]);}
listeners=newListeners;}
originalRemoveEventListener.call(this,type,listener);};var KeyEventProto={DOM_VK_HOME:36};window.addEventListener('message',function(event){var data=event.data;if(typeof data==='string'&&data.indexOf('moz-key-')==0){var type,key;if(data.indexOf('moz-key-down-')==0){type='keydown';key=data.substr(13);}else if(data.indexOf('moz-key-up-')==0){type='keyup';key=data.substr(11);}else{return;}
key=KeyEvent[key];for(var n=0;n<listeners.length;++n){if(listeners[n].type==type){var fn=listeners[n].listener;var e=Object.create(KeyEventProto);e.type=type;e.keyCode=key;if(typeof fn==='function')
fn(e);else if(typeof fn==='object'&&fn.handleEvent)
fn.handleEvent(e);if(listeners[n].capture)
return;}}}});})(this);;'use strict';var NotificationHelper={_referencesArray:[],getIconURI:function nc_getIconURI(app,entryPoint){var icons=app.manifest.icons;if(entryPoint){icons=app.manifest.entry_points[entryPoint].icons;}
if(!icons)
return null;var sizes=Object.keys(icons).map(function parse(str){return parseInt(str,10);});sizes.sort(function(x,y){return y-x;});var HVGA=document.documentElement.clientWidth<480;var index=sizes[HVGA?sizes.length-1:0];return app.installOrigin+icons[index];},send:function nc_send(title,body,icon,clickCB,closeCB){if(!('mozNotification'in navigator))
return;var notification=navigator.mozNotification.createNotification(title,body,icon);notification.onclick=(function(){if(clickCB)
clickCB();this._forget(notification);}).bind(this);notification.onclose=(function(){if(closeCB)
closeCB();this._forget(notification);}).bind(this);notification.show();this._keep(notification);},_keep:function nc_keep(notification){this._referencesArray.push(notification);},_forget:function nc_forget(notification){this._referencesArray.splice(this._referencesArray.indexOf(notification),1);}};;'use strict';var BlackList=(function(){var _blackList={};function _init(){var xhr=new XMLHttpRequest();xhr.overrideMimeType('application/json');xhr.open('GET','js/blacklist.json',true);xhr.send(null);xhr.onreadystatechange=function cc_loadConfiguration(evt){if(xhr.readyState!=4)
return;if(xhr.status==0||xhr.status==200){var list=JSON.parse(xhr.responseText);_blackList={};list.forEach(function sms_bl_addToBL(item){_blackList[item]=true;});}}}
function _has(value){return _blackList.hasOwnProperty(value);}
return{init:_init,has:_has};}());BlackList.init();;'use strict';var ContactDataManager={contactData:{},getContactData:function cm_getContactData(number,callback){if(!navigator.mozContacts){return;}
var options={filterBy:['tel'],filterOp:'contains',filterValue:number};var self=this;var req=window.navigator.mozContacts.find(options);req.onsuccess=function onsuccess(){var result=req.result;callback(result);};req.onerror=function onerror(){var msg='Contact finding error. Error: '+req.errorCode;console.log(msg);callback(null);};},searchContactData:function cm_searchContactData(string,callback){if(!navigator.mozSms)
return;var options={filterBy:['tel','givenName','familyName'],filterOp:'contains',filterValue:string};var self=this;var req=window.navigator.mozContacts.find(options);req.onsuccess=function onsuccess(){callback(req.result);};req.onerror=function onerror(){var msg='Contact finding error. Error: '+req.errorCode;console.log(msg);callback(null);};}};;'use strict';var MessageManager={init:function mm_init(){this.initialized=true;MessageManager.getThreads(ThreadListUI.renderThreads);ThreadUI.init();ThreadListUI.init();if(navigator.mozSms){navigator.mozSms.addEventListener('received',this.onMessageReceived.bind(this));navigator.mozSms.addEventListener('sending',this.onMessageSending);navigator.mozSms.addEventListener('sent',this.onMessageSent);navigator.mozSms.addEventListener('failed',this.onMessageFailed);}
window.addEventListener('hashchange',this.onHashChange.bind(this));document.addEventListener('mozvisibilitychange',this.onVisibilityChange.bind(this));this.fullHeight=ThreadListUI.view.offsetHeight;},onMessageSending:function mm_onMessageSending(e){var message=e.message;var num=message.receiver;if(window.location.hash=='#new'){window.location.hash='#num='+num;}else{ThreadUI.appendMessage(message);}
MessageManager.getThreads(ThreadListUI.renderThreads);},onMessageFailed:function mm_onMessageFailed(e){ThreadUI.onMessageFailed(e.message);},onMessageSent:function mm_onMessageSent(e){ThreadUI.onMessageSent(e.message);},createThreadMockup:function mm_createThreadMockup(message){return{senderOrReceiver:message.sender,body:message.body,timestamp:message.timestamp,unreadCount:1};},onMessageReceived:function mm_onMessageReceived(e){var message=e.message;var num;if(this.currentNum){num=this.currentNum;}
var sender=message.sender;if(num&&num===sender){this.markMessagesRead([message.id],true,function(){MessageManager.getThreads(ThreadListUI.renderThreads);});ThreadUI.appendMessage(message);Utils.updateTimeHeaders();}else{var threadMockup=this.createThreadMockup(message);if(ThreadListUI.view.getElementsByTagName('ul').length===0){ThreadListUI.renderThreads([threadMockup]);}else{var num=threadMockup.senderOrReceiver;var timestamp=threadMockup.timestamp.getTime();var previousThread=document.getElementById('thread_'+num);if(previousThread&&previousThread.dataset.time>timestamp){previousThread.getElementsByTagName('a')[0].classList.add('unread');return;}
if(previousThread){var threadsInContainer=previousThread.parentNode.children.length;if(threadsInContainer===1){var oldThreadContainer=previousThread.parentNode;var oldHeaderContainer=oldThreadContainer.previousSibling;ThreadListUI.view.removeChild(oldThreadContainer);ThreadListUI.view.removeChild(oldHeaderContainer);}else{var threadsContainerID='threadsContainer_'+
Utils.getDayDate(threadMockup.timestamp);var threadsContainer=document.getElementById(threadsContainerID);threadsContainer.removeChild(previousThread);}}
ThreadListUI.appendThread(threadMockup);}}},onVisibilityChange:function mm_onVisibilityChange(e){ThreadListUI.updateContactsInfo();ThreadUI.updateHeaderData();},slide:function mm_slide(callback){var mainWrapper=document.getElementById('main-wrapper');mainWrapper.classList.add('peek');mainWrapper.dataset.position=(mainWrapper.dataset.position=='left')?'right':'left';var trEndCount=0;mainWrapper.addEventListener('transitionend',function trWait(){trEndCount++;switch(trEndCount){case 2:mainWrapper.classList.remove('peek');break;case 4:mainWrapper.removeEventListener('transitionend',trWait);if(callback){callback();}
break;}});},onHashChange:function mm_onHashChange(e){var mainWrapper=document.getElementById('main-wrapper');var threadMessages=document.getElementById('thread-messages');switch(window.location.hash){case'#new':var messageInput=document.getElementById('message-to-send');var receiverInput=document.getElementById('receiver-input');var contactButton=document.getElementById('icon-contact');contactButton.parentNode.appendChild(contactButton);document.getElementById('messages-container').innerHTML='';ThreadUI.cleanFields();MessageManager.currentNum=null;threadMessages.classList.add('new');MessageManager.slide(function(){receiverInput.focus();});break;case'#thread-list':var editButton=document.getElementById('icon-edit');editButton.parentNode.appendChild(editButton);MessageManager.currentNum=null;if(mainWrapper.classList.contains('edit')){if(ThreadListUI.editDone){ThreadListUI.editDone=false;this.getThreads(ThreadListUI.renderThreads);}
mainWrapper.classList.remove('edit');}else if(threadMessages.classList.contains('new')){MessageManager.slide(function(){threadMessages.classList.remove('new');});}else{MessageManager.slide(function(){ThreadUI.view.innerHTML='';if(MessageManager.activityTarget){window.location.hash='#num='+MessageManager.activityTarget;delete MessageManager.activityTarget;delete MessageManager.lockActivity;}});}
break;case'#edit':ThreadListUI.cleanForm();ThreadUI.cleanForm();mainWrapper.classList.toggle('edit');break;default:var num=this.getNumFromHash();if(num){var filter=this.createFilter(num);var messageInput=document.getElementById('message-to-send');MessageManager.currentNum=num;if(mainWrapper.classList.contains('edit')){mainWrapper.classList.remove('edit');}else if(threadMessages.classList.contains('new')){this.getMessages(ThreadUI.renderMessages,filter,false);threadMessages.classList.remove('new');ThreadUI.updateHeaderData();}else{var threadRead=document.getElementById('thread_'+num);if(threadRead){threadRead.getElementsByTagName('a')[0].classList.remove('unread');}
var self=this;ThreadUI.updateHeaderData(function headerReady(){MessageManager.slide(function slided(){self.getMessages(ThreadUI.renderMessages,filter,false);});});}}
break;}},createFilter:function mm_createFilter(num){var filter=new MozSmsFilter();filter.numbers=[num||''];return filter;},getNumFromHash:function mm_getNumFromHash(){var num=/\bnum=(.+)(&|$)/.exec(window.location.hash);return num?num[1]:null;},getThreads:function mm_getThreads(callback,extraArg){var request=navigator.mozSms.getThreadList();request.onsuccess=function onsuccess(evt){var threads=evt.target.result;if(callback){callback(threads,extraArg);}};request.onerror=function onerror(){var msg='Reading the database. Error: '+request.errorCode;console.log(msg);};},getMessages:function mm_getMessages(callback,filter,invert,callbackArgs){var request=navigator.mozSms.getMessages(filter,!invert);var self=this;var messages=[];request.onsuccess=function onsuccess(){var cursor=request.result;if(cursor.message){messages.push(cursor.message);cursor.continue();}else{callback(messages,callbackArgs);}};request.onerror=function onerror(){var msg='Reading the database. Error: '+request.errorCode;console.log(msg);};},send:function mm_send(number,text,callback,errorHandler){var req=navigator.mozSms.send(number,text);req.onsuccess=function onsuccess(e){callback&&callback(req.result);};req.onerror=function onerror(e){errorHandler&&errorHandler(number);};},deleteMessage:function mm_deleteMessage(id,callback){var req=navigator.mozSms.delete(id);req.onsuccess=function onsuccess(){callback&&callback(req.result);};req.onerror=function onerror(){var msg='Deleting in the database. Error: '+req.errorCode;console.log(msg);callback&&callback(null);};},deleteMessages:function mm_deleteMessages(list,callback){if(list.length>0){this.deleteMessage(list.shift(),function(result){this.deleteMessages(list,callback);}.bind(this));}else
callback();},markMessagesRead:function mm_markMessagesRead(list,value,callback){if(!navigator.mozSms||!list.length){return;}
var req=navigator.mozSms.markMessageRead(list.pop(),value);req.onsuccess=(function onsuccess(){if(!list.length&&callback){callback(req.result);return;}
this.markMessagesRead(list,value,callback);}).bind(this);req.onerror=function onerror(){if(callback){callback(null);}};}};var ThreadListUI={get view(){delete this.view;return this.view=document.getElementById('thread-list-container');},get selectAllButton(){delete this.selectAllButton;return this.selectAllButton=document.getElementById('select-all-threads');},get deselectAllButton(){delete this.deselectAllButton;return this.deselectAllButton=document.getElementById('deselect-all-threads');},get deleteButton(){delete this.deleteButton;return this.deleteButton=document.getElementById('threads-delete-button');},get cancelButton(){delete this.cancelButton;return this.cancelButton=document.getElementById('threads-cancel-button');},get iconEdit(){delete this.iconEdit;return this.iconEdit=document.getElementById('icon-edit-threads');},get pageHeader(){delete this.pageHeader;return this.pageHeader=document.getElementById('list-edit-title');},get editForm(){delete this.editForm;return this.editForm=document.getElementById('threads-edit-form');},init:function thlui_init(){this.delNumList=[];this.selectedInputList=[];this.selectAllButton.addEventListener('click',this.selectAllThreads.bind(this));this.deselectAllButton.addEventListener('click',this.deselectAllThreads.bind(this));this.deleteButton.addEventListener('click',this.executeDeletion.bind(this));this.cancelButton.addEventListener('click',this.cancelEditMode.bind(this));this.view.addEventListener('click',this);this.editForm.addEventListener('submit',this);},updateThreadWithContact:function thlui_updateThreadWithContact(number,thread){ContactDataManager.getContactData(number,function gotContact(contacts){if(!contacts||!Array.isArray(contacts)||contacts.length<1){return;}
var nameContainer=thread.getElementsByClassName('name')[0];var contact=contacts[0];var contactName=contact.name;if(contacts.length>1){var others=contacts.length-1;nameContainer.innerHTML=_('others',{name:contactName,n:others});}else{nameContainer.innerHTML=contactName;}
if(contact.photo&&contact.photo[0]){var photo=thread.getElementsByTagName('img')[0];var photoURL=URL.createObjectURL(contact.photo[0]);photo.src=photoURL;}});},handleEvent:function thlui_handleEvent(evt){switch(evt.type){case'click':if(evt.target.type=='checkbox'){ThreadListUI.clickInput(evt.target);ThreadListUI.checkInputs();}
break;case'submit':evt.preventDefault();return false;break;}},clickInput:function thlui_clickInput(target){if(target.checked){ThreadListUI.selectedInputList.push(target);}else{ThreadListUI.selectedInputList.splice(ThreadListUI.selectedInputList.indexOf(target),1);}},checkInputs:function thlui_checkInputs(){var selected=ThreadListUI.selectedInputList.length;var allInputs=ThreadListUI.view.querySelectorAll('input[type="checkbox"]');if(selected==allInputs.length){ThreadListUI.selectAllButton.classList.add('disabled');}else{ThreadListUI.selectAllButton.classList.remove('disabled');}
if(selected>0){ThreadListUI.deselectAllButton.classList.remove('disabled');ThreadListUI.deleteButton.classList.remove('disabled');this.pageHeader.innerHTML=_('selected',{n:selected});}else{ThreadListUI.deselectAllButton.classList.add('disabled');ThreadListUI.deleteButton.classList.add('disabled');this.pageHeader.innerHTML=_('editMode');}},cleanForm:function thlui_cleanForm(){var inputs=this.view.querySelectorAll('input[type="checkbox"]');for(var i=0;i<inputs.length;i++){inputs[i].checked=false;inputs[i].parentNode.parentNode.classList.remove('undo-candidate');}
this.delNumList=[];this.selectedInputList=[];this.pageHeader.innerHTML=_('editMode');this.checkInputs();},selectAllThreads:function thlui_selectAllThreads(){var inputs=this.view.querySelectorAll('input[type="checkbox"]:not(:checked)');for(var i=0;i<inputs.length;i++){inputs[i].checked=true;ThreadListUI.clickInput(inputs[i]);}
ThreadListUI.checkInputs();},deselectAllThreads:function thlui_deselectAllThreads(){var inputs=this.view.querySelectorAll('input[type="checkbox"]:checked');for(var i=0;i<inputs.length;i++){inputs[i].checked=false;ThreadListUI.clickInput(inputs[i]);}
ThreadListUI.checkInputs();},executeDeletion:function thlui_executeDeletion(){var response=window.confirm(_('deleteThreads-confirmation2'));if(response){WaitingScreen.show();var inputs=ThreadListUI.selectedInputList;var nums=inputs.map(function(input){return input.value;});var filter=new MozSmsFilter();filter.numbers=nums;MessageManager.getMessages(function gotMessages(messages){var delNumList=messages.map(function(message){return message.id;});MessageManager.deleteMessages(delNumList,function(){MessageManager.getThreads(function recoverThreads(threads){ThreadListUI.renderThreads(threads);WaitingScreen.hide();ThreadListUI.editDone=true;window.location.hash='#thread-list';});});},filter);}},cancelEditMode:function thlui_cancelEditMode(){window.location.hash='#thread-list';},renderThreads:function thlui_renderThreads(threads,callback){ThreadListUI.view.innerHTML='';if(threads.length>0){document.getElementById('threads-fixed-container').classList.remove('hide');FixedHeader.init('#thread-list-container','#threads-fixed-container','header');ThreadListUI.iconEdit.classList.remove('disabled');var appendThreads=function(threads,callback){if(threads.length===0){FixedHeader.refresh();if(callback){callback();}
return;}
var thread=threads.pop();setTimeout(function(){ThreadListUI.appendThread(thread);appendThreads(threads,callback);});};appendThreads(threads,function at_callback(){Utils.updateTimeHeaders();});}else{document.getElementById('threads-fixed-container').classList.add('hide');var noResultHTML='<div id="no-result-container">'+' <div id="no-result-message">'+'   <p>'+_('noMessages-title')+'</p>'+'   <p>'+_('noMessages-text')+'</p>'+' </div>'+'</div>';ThreadListUI.view.innerHTML=noResultHTML;ThreadListUI.iconEdit.classList.add('disabled');}
if(callback){callback();}},createThread:function thlui_createThread(thread){var num=thread.senderOrReceiver;var timestamp=thread.timestamp.getTime();var threadDOM=document.createElement('li');threadDOM.id='thread_'+num;threadDOM.dataset.time=timestamp;var bodyText=(thread.body||'').split('\n')[0];var formattedDate=Utils.getFormattedHour(timestamp);var structureHTML='<label class="danger">'+'<input type="checkbox" value="'+num+'">'+'<span></span>'+'</label>'+'<a href="#num='+num+'" class="'+
(thread.unreadCount>0?'unread':'')+'">'+'<aside class="icon icon-unread">unread</aside>'+'<aside class="pack-end">'+'<img src="">'+'</aside>'+'<p class="name">'+num+'</p>'+'<p><time>'+formattedDate+'</time>'+bodyText+'</p>'+'</a>';threadDOM.innerHTML=structureHTML;return threadDOM;},insertThreadContainer:function thlui_insertThreadContainer(fragment,timestamp){var headers=ThreadListUI.view.getElementsByTagName('header');var groupFound=false;for(var i=0;i<headers.length;i++){if(timestamp>=headers[i].dataset.time){groupFound=true;ThreadListUI.view.insertBefore(fragment,headers[i]);break;}}
if(!groupFound){ThreadListUI.view.appendChild(fragment);}},appendThread:function thlui_appendThread(thread){var num=thread.senderOrReceiver;var timestamp=thread.timestamp.getTime();var threadDOM=this.createThread(thread);ThreadListUI.updateThreadWithContact(num,threadDOM);var threadsContainerID='threadsContainer_'+
Utils.getDayDate(thread.timestamp);var threadsContainer=document.getElementById(threadsContainerID);if(!threadsContainer){var threadsContainerFragment=ThreadListUI.createThreadContainer(timestamp);threadsContainer=threadsContainerFragment.childNodes[1];ThreadListUI.insertThreadContainer(threadsContainerFragment,timestamp);}
var threads=ThreadListUI.view.getElementsByTagName('li');var threadFound=false;for(var i=0;i<threads.length;i++){if(timestamp>threads[i].dataset.time){threadFound=true;threadsContainer.insertBefore(threadDOM,threads[i]);break;}}
if(!threadFound){threadsContainer.appendChild(threadDOM);}},createThreadContainer:function thlui_createThreadContainer(timestamp){var threadContainer=document.createDocumentFragment();var headerDOM=document.createElement('header');headerDOM.dataset.timeUpdate=true;headerDOM.dataset.time=timestamp;headerDOM.dataset.isThread=true;var threadsContainerDOM=document.createElement('ul');threadsContainerDOM.id='threadsContainer_'+
Utils.getDayDate(timestamp);headerDOM.innerHTML=Utils.getHeaderDate(timestamp);threadContainer.appendChild(headerDOM);threadContainer.appendChild(threadsContainerDOM);return threadContainer;},updateContactsInfo:function mm_updateContactsInfo(){var threads=ThreadListUI.view.getElementsByTagName('li');for(var i=0;i<threads.length;i++){var thread=threads[i];var num=thread.id.replace('thread_','');ThreadListUI.updateThreadWithContact(num,thread);}}};var ThreadUI={get view(){delete this.view;return this.view=document.getElementById('messages-container');},get contactInput(){delete this.contactInput;return this.contactInput=document.getElementById('receiver-input');},get backButton(){delete this.backButton;return this.backButton=document.getElementById('go-to-threadlist');},get clearButton(){delete this.clearButton;return this.clearButton=document.getElementById('clear-search');},get title(){delete this.title;return this.title=document.getElementById('header-text');},get input(){delete this.input;return this.input=document.getElementById('message-to-send');},get sendButton(){delete this.sendButton;return this.sendButton=document.getElementById('send-message');},get pickButton(){delete this.pickButton;return this.pickButton=document.getElementById('icon-contact');},get selectAllButton(){delete this.deleteAllButton;return this.deleteAllButton=document.getElementById('select-all-messages');},get deselectAllButton(){delete this.deselectAllButton;return this.deselectAllButton=document.getElementById('deselect-all-messages');},get deleteButton(){delete this.doneButton;return this.doneButton=document.getElementById('messages-delete-button');},get cancelButton(){delete this.cancelButton;return this.cancelButton=document.getElementById('messages-cancel-button');},get pageHeader(){delete this.pageHeader;return this.pageHeader=document.getElementById('messages-edit-title');},get editForm(){delete this.editForm;return this.editForm=document.getElementById('messages-edit-form');},get telForm(){delete this.telForm;return this.telForm=document.getElementById('messages-tel-form');},get sendForm(){delete this.sendForm;return this.sendForm=document.getElementById('new-sms-form');},init:function thui_init(){this.sendButton.addEventListener('click',this.sendMessage.bind(this));this.sendButton.addEventListener('mousedown',function btnDown(event){event.preventDefault();event.target.classList.add('active');});this.sendButton.addEventListener('mouseup',function btnUp(event){event.target.classList.remove('active');});this.sendButton.addEventListener('mouseout',function mouseOut(event){event.target.classList.remove('active');});this.backButton.addEventListener('click',this.onBackAction.bind(this));this.pickButton.addEventListener('click',this.pickContact.bind(this));this.selectAllButton.addEventListener('click',this.selectAllMessages.bind(this));this.deselectAllButton.addEventListener('click',this.deselectAllMessages.bind(this));this.cancelButton.addEventListener('click',this.cancelEditMode.bind(this));this.input.addEventListener('input',this.updateInputHeight.bind(this));this.input.addEventListener('input',this.enableSend.bind(this));this.contactInput.addEventListener('input',this.searchContact.bind(this));this.contactInput.addEventListener('input',this.enableSend.bind(this));this.deleteButton.addEventListener('click',this.executeDeletion.bind(this));this.title.addEventListener('click',this.activateContact.bind(this));this.clearButton.addEventListener('click',this.clearContact.bind(this));this.view.addEventListener('click',this);this.editForm.addEventListener('submit',this);this.telForm.addEventListener('submit',this);this.sendForm.addEventListener('submit',this);Utils.startTimeHeaderScheduler();},onBackAction:function thui_onBackAction(){var goBack=function(){if(ThreadUI.input.value.length==0){window.location.hash='#thread-list';return;}
var response=window.confirm(_('discard-sms'));if(response){ThreadUI.cleanFields(true);window.location.hash='#thread-list';}};if(MessageManager.fullHeight!==this.view.offsetHeight){window.addEventListener('resize',function keyboardHidden(){window.removeEventListener('resize',keyboardHidden);goBack();});}else{goBack();}},enableSend:function thui_enableSend(){if(this.input.value.length>0){this.updateCounter();}
if(window.location.hash=='#new'&&this.contactInput.value.length==0){this.sendButton.disabled=true;return;}
this.sendButton.disabled=!(this.input.value.length>0);},scrollViewToBottom:function thui_scrollViewToBottom(){this.view.scrollTop=this.view.scrollHeight;},updateCounter:function thui_updateCount(evt){if(!navigator.mozSms){return;}
var value=this.input.value;var kMaxConcatenatedMessages=10;var smsInfo=navigator.mozSms.getSegmentInfoForText(value);var segments=smsInfo.segments;var availableChars=smsInfo.charsAvailableInLastSegment;var counter='';if(segments>1){counter=availableChars+'/'+segments;}
this.sendButton.dataset.counter=counter;this.sendButton.disabled=(segments>kMaxConcatenatedMessages);},updateInputHeight:function thui_updateInputHeight(){var input=this.input;var inputCss=window.getComputedStyle(input,null);var inputMaxHeight=parseInt(inputCss.getPropertyValue('max-height'),10);var deviationHeight=30;if(input.scrollHeight>inputMaxHeight){return;}
input.style.height=null;input.style.height=input.offsetHeight>input.scrollHeight?input.offsetHeight/Utils.getFontSize()+'rem':input.scrollHeight/Utils.getFontSize()+'rem';var newHeight=input.getBoundingClientRect().height;var bottomToolbarHeight=(newHeight/Utils.getFontSize()+0.7)+'rem';var sendButtonTranslate=(input.offsetHeight-deviationHeight)/Utils.getFontSize()+'rem';var bottomToolbar=document.querySelector('#new-sms-form');bottomToolbar.style.height=bottomToolbarHeight;ThreadUI.sendButton.style.marginTop=sendButtonTranslate;this.view.style.bottom=bottomToolbarHeight;this.scrollViewToBottom();},createTimeHeader:function thui_createTimeHeader(time,hourOnly,fragment){var headerDOM=document.createElement('header');headerDOM.dataset.timeUpdate=true;headerDOM.dataset.time=time;var content;if(!hourOnly){content=Utils.getHeaderDate(time)+' '+
Utils.getFormattedHour(time);}else{content=Utils.getFormattedHour(time);headerDOM.dataset.hourOnly='true';}
headerDOM.innerHTML=content;fragment.appendChild(headerDOM);var messagesContainerDOM=document.createElement('ul');fragment.appendChild(messagesContainerDOM);},updateHeaderData:function thui_updateHeaderData(callback){if(!navigator.mozSms&&callback){setTimeout(callback);return;}
var number=MessageManager.currentNum;if(!number){return;}
var self=this;this.title.dataset.phoneNumber=number;ContactDataManager.getContactData(number,function gotContact(contacts){var carrierTag=document.getElementById('contact-carrier');if(contacts.length>1){self.title.dataset.isContact=true;var contactName=contacts[0].name;var numOthers=contacts.length-1;self.title.innerHTML=_('others',{name:contactName,n:numOthers});carrierTag.classList.add('hide');}else{Utils.getPhoneDetails(number,contacts[0],function returnedDetails(details){if(details.isContact){self.title.dataset.isContact=true;}else{delete self.title.dataset.isContact;}
self.title.innerHTML=details.title||number;if(details.carrier){carrierTag.innerHTML=details.carrier;carrierTag.classList.remove('hide');}else{carrierTag.classList.add('hide');}});}
if(callback){callback();}});},renderMessages:function thui_renderMessages(messages,callback){ThreadUI.cleanFields();ThreadUI.delNumList=[];ThreadUI.checkInputs();ThreadUI.view.innerHTML='';ThreadUI.dayHeaderIndex=0;ThreadUI.timeHeaderIndex=0;ThreadUI.readMessages=[];ThreadUI.appendMessages(messages);if(ThreadUI.readMessages.length>0){MessageManager.markMessagesRead(ThreadUI.readMessages,'true',function(){MessageManager.getThreads(ThreadListUI.renderThreads);});}
Utils.updateTimeHeaders();if(callback){setTimeout(function(){callback();});}},appendMessage:function thui_appendMessage(message){this.appendMessages([message]);},appendMessages:function thui_appendMessages(messages){var fragment=document.createDocumentFragment();var lastChild=fragment.lastChild;for(var i=messages.length-1;i>=0;i--){var message=messages[i];if(!message.read){ThreadUI.readMessages.push(message.id);}
var id=message.id;var bodyText=message.body;var bodyHTML=Utils.escapeHTML(bodyText);var messageClass=message.delivery;var messageDOM=document.createElement('li');messageDOM.classList.add('bubble');messageDOM.id='message-'+id;var inputValue=id;var asideHTML='';switch(message.delivery){case'error':asideHTML='<aside class="pack-end"></aside>';ThreadUI.addResendHandler(message,messageDOM);break;case'sending':asideHTML='<aside class="pack-end">'+'<progress></progress></aside>';break;}
var messageHTML='<label class="danger">'+'<input type="checkbox" value="'+inputValue+'">'+'<span></span>'+'</label>'+'<a class="'+messageClass+'">';messageHTML+=asideHTML;messageHTML+='<p>'+bodyHTML+'</p></a>';messageDOM.innerHTML=messageHTML;var timestamp=message.timestamp.getTime();var tmpDayIndex=Utils.getDayDate(timestamp);var tmpHourIndex=timestamp;if(tmpDayIndex>ThreadUI.dayHeaderIndex){ThreadUI.createTimeHeader(timestamp,false,fragment);ThreadUI.dayHeaderIndex=tmpDayIndex;ThreadUI.timeHeaderIndex=tmpHourIndex;lastChild=fragment.lastChild;}else{if(tmpHourIndex>ThreadUI.timeHeaderIndex+10*60*1000){ThreadUI.createTimeHeader(timestamp,true,fragment);ThreadUI.timeHeaderIndex=tmpHourIndex;lastChild=fragment.lastChild;}else if(!lastChild){lastChild=fragment;}}
lastChild.appendChild(messageDOM);}
(fragment===lastChild)?ThreadUI.view.lastChild.appendChild(fragment):ThreadUI.view.appendChild(fragment);ThreadUI.scrollViewToBottom();},addResendHandler:function thui_addResendHandler(message,messageDOM){messageDOM.addEventListener('click',function resend(e){var hash=window.location.hash;if(hash!='#edit'){var resendConfirmStr=_('resend-confirmation');var result=confirm(resendConfirmStr);if(result){messageDOM.removeEventListener('click',resend);ThreadUI.resendMessage(message,messageDOM);}}});},cleanForm:function thui_cleanForm(){var inputs=this.view.querySelectorAll('input[type="checkbox"]');for(var i=0;i<inputs.length;i++){inputs[i].checked=false;inputs[i].parentNode.parentNode.classList.remove('undo-candidate');}
this.checkInputs();},clearContact:function thui_clearContact(){this.contactInput.value='';this.view.innerHTML='';},selectAllMessages:function thui_selectAllMessages(){var inputs=this.view.querySelectorAll('input[type="checkbox"]:not(:checked)');for(var i=0;i<inputs.length;i++){inputs[i].checked=true;ThreadUI.chooseMessage(inputs[i]);}
ThreadUI.checkInputs();},deselectAllMessages:function thui_deselectAllMessages(){var inputs=this.view.querySelectorAll('input[type="checkbox"]:checked');for(var i=0;i<inputs.length;i++){inputs[i].checked=false;ThreadUI.chooseMessage(inputs[i]);}
ThreadUI.checkInputs();},executeDeletion:function thui_executeDeletion(){var response=window.confirm(_('deleteMessages-confirmation'));if(response){WaitingScreen.show();var delNumList=[];var inputs=ThreadUI.view.querySelectorAll('input[type="checkbox"]:checked');for(var i=0;i<inputs.length;i++){delNumList.push(parseInt(inputs[i].value,10));}
var deleteMessages=function(){MessageManager.getThreads(ThreadListUI.renderThreads,function afterRender(){var completeDeletionDone=false;for(var i=0;i<inputs.length;i++){var message=inputs[i].parentNode.parentNode;var messagesContainer=message.parentNode;if(messagesContainer.childNodes.length==1){var header=messagesContainer.previousSibling;ThreadUI.view.removeChild(header);ThreadUI.view.removeChild(messagesContainer);if(!ThreadUI.view.childNodes.length){var mainWrapper=document.getElementById('main-wrapper');mainWrapper.classList.remove('edit');window.location.hash='#thread-list';WaitingScreen.hide();completeDeletionDone=true;break;}}else{messagesContainer.removeChild(message);}}
if(!completeDeletionDone){window.history.back();WaitingScreen.hide();}});};MessageManager.deleteMessages(delNumList,deleteMessages);}},cancelEditMode:function thlui_cancelEditMode(){window.history.go(-1);},chooseMessage:function thui_chooseMessage(target){if(!target.checked){target.parentNode.parentNode.classList.remove('selected');}else{target.parentNode.parentNode.classList.add('selected');}},checkInputs:function thui_checkInputs(){var selected=this.view.querySelectorAll('input[type="checkbox"]:checked');var allInputs=this.view.querySelectorAll('input[type="checkbox"]');if(selected.length==allInputs.length){ThreadUI.selectAllButton.classList.add('disabled');}else{ThreadUI.selectAllButton.classList.remove('disabled');}
if(selected.length>0){ThreadUI.deselectAllButton.classList.remove('disabled');ThreadUI.deleteButton.classList.remove('disabled');this.pageHeader.innerHTML=_('selected',{n:selected.length});}else{ThreadUI.deselectAllButton.classList.add('disabled');ThreadUI.deleteButton.classList.add('disabled');this.pageHeader.innerHTML=_('editMode');}},handleEvent:function thui_handleEvent(evt){switch(evt.type){case'click':if(window.location.hash!='#edit'){return;}
var inputs=evt.target.parentNode.getElementsByTagName('input');if(inputs&&inputs.length>0){ThreadUI.chooseMessage(inputs[0]);ThreadUI.checkInputs();}
break;case'submit':evt.preventDefault();return false;break;}},cleanFields:function thui_cleanFields(forceClean){var self=this;var clean=function clean(){self.input.value='';self.sendButton.disabled=true;self.sendButton.dataset.counter='';self.contactInput.value='';self.updateInputHeight();};if(window.location.hash==this.previousHash||this.previousHash=='#new'){if(forceClean){clean();}}else{clean();}
this.enableSend();this.previousHash=window.location.hash;},sendMessage:function thui_sendMessage(resendText){var num,text;if(resendText&&(typeof(resendText)==='string')&&resendText!==''){num=MessageManager.currentNum;text=resendText;}else{var hash=window.location.hash;if(hash=='#new'){num=this.contactInput.value;if(!num){return;}}else{num=MessageManager.currentNum;}
text=this.input.value;if(!text){return;}}
this.cleanFields(true);MessageManager.currentNum=num;this.updateHeaderData();MessageManager.send(num,text);},onMessageSent:function thui_onMessageSent(message){var messageDOM=document.getElementById('message-'+message.id);if(!messageDOM){return;}
var aElement=messageDOM.querySelector('a');aElement.classList.remove('sending');var spinnerContainer=aElement.querySelector('aside');aElement.removeChild(spinnerContainer);},onMessageFailed:function thui_onMessageFailed(message){var messageDOM=document.getElementById('message-'+message.id);if(!messageDOM){return;}
var aElement=messageDOM.querySelector('a');if(!aElement.classList.contains('sending')){return;}
aElement.classList.remove('sending');aElement.classList.add('error');var spinnerContainer=aElement.querySelector('aside');spinnerContainer.innerHTML='';ThreadUI.addResendHandler(message,messageDOM);this.ifRilDisabled(this.showAirplaneModeError);},ifRilDisabled:function thui_ifRilDisabled(func){var settings=window.navigator.mozSettings;if(settings){var req=settings.createLock().get('ril.radio.disabled');req.addEventListener('success',function onsuccess(){var rilDisabled=req.result['ril.radio.disabled'];rilDisabled&&func();});}},showAirplaneModeError:function thui_showAirplaneModeError(){CustomDialog.show(_('sendAirplaneModeTitle'),_('sendAirplaneModeBody'),{title:_('sendAirplaneModeBtnOk'),callback:function(){CustomDialog.hide();}});},resendMessage:function thui_resendMessage(message,messageDOM){var messagesContainer=messageDOM.parentNode;if(messagesContainer.childNodes.length==1){var header=messagesContainer.previousSibling;ThreadUI.view.removeChild(header);ThreadUI.view.removeChild(messagesContainer);}else{messageDOM.parentNode.removeChild(messageDOM);}
if(!ThreadUI.view.childNodes.length){ThreadUI.dayHeaderIndex=0;ThreadUI.timeHeaderIndex=0;}
if(message.id){MessageManager.deleteMessage(message.id);}
ThreadUI.sendMessage(message.body);},renderContactData:function thui_renderContactData(contact){var self=this;var tels=contact.tel;var contactsContainer=document.createElement('ul');contactsContainer.classList.add('contactList');for(var i=0;i<tels.length;i++){Utils.getPhoneDetails(tels[i].value,contact,function gotDetails(details){var name=(contact.name||details.title).toString();var number=tels[i].value.toString();var input=self.contactInput.value;var regName=new RegExp('\\b'+input,'ig');var regNumber=new RegExp(input,'ig');if(!(name.match(regName)||number.match(regNumber))){return;}
var nameHTML=SearchUtils.createHighlightHTML(name,regName,'highlight');var numHTML=SearchUtils.createHighlightHTML(number,regNumber,'highlight');var contactDOM=document.createElement('li');if(contact.photo&&contact.photo[0]){var photoURL=URL.createObjectURL(contact.photo[0]);}
var structureHTML='  <a href="#num='+number+'">'+'<aside class="pack-end">'+'<img '+(photoURL?'src="'+photoURL+'"':'')+'>'+'</aside>'+'    <p class="name">'+nameHTML+'</div>'+'    <p>'+
tels[i].type+' '+numHTML+' '+(tels[i].carrier?tels[i].carrier:'')+'    </p>'+'  </a>';contactDOM.innerHTML=structureHTML;contactsContainer.appendChild(contactDOM);});}
ThreadUI.view.appendChild(contactsContainer);},searchContact:function thui_searchContact(){var input=this.contactInput;var string=input.value;var self=this;self.view.innerHTML='';if(!string){return;}
var contactsContainer=document.createElement('ul');ContactDataManager.searchContactData(string,function gotContact(contacts){self.view.innerHTML='';if(!contacts||contacts.length==0){var contactDOM=document.createElement('li');var noResultHTML='<a><p data-l10n-id="no-results">'+
_('no-results')+'</p></a>';contactDOM.innerHTML=noResultHTML;contactsContainer.appendChild(contactDOM);self.view.appendChild(contactsContainer);return;}
contacts.forEach(self.renderContactData.bind(self));});},pickContact:function thui_pickContact(){try{var activity=new MozActivity({name:'pick',data:{type:'webcontacts/contact'}});activity.onsuccess=function success(){var number=this.result.number;if(number){window.location.hash='#num='+number;}};}catch(e){console.log('WebActivities unavailable? : '+e);}},activateContact:function thui_activateContact(){var options={};if(this.title.dataset.isContact=='true'){}else{options={name:'new',data:{type:'webcontacts/contact',params:{'tel':this.title.dataset.phoneNumber}}};}
try{var activity=new MozActivity(options);activity.onsuccess=ThreadUI.onCreateContact;}catch(e){console.log('WebActivities unavailable? : '+e);}},onCreateContact:function thui_onCreateContact(){ThreadListUI.updateContactsInfo();if(window.location.hash.substr(0,5)==='#num='){ThreadUI.updateHeaderData();}}};var WaitingScreen={get loading(){delete this.loading;return this.loading=document.getElementById('loading');},get loadingHeader(){delete this.loadingHeader;return this.loadingHeader=document.getElementById('loading-header');},show:function ws_show(){this.loading.classList.add('show-loading');},hide:function ws_hide(){this.loading.classList.remove('show-loading');},update:function ws_update(text){this.loadingHeader.innerHTML=text;}};window.addEventListener('resize',function resize(){ThreadUI.scrollViewToBottom();});window.addEventListener('localized',function showBody(){if(!MessageManager.initialized){MessageManager.init();}
document.documentElement.lang=navigator.mozL10n.language.code;document.documentElement.dir=navigator.mozL10n.language.direction;});function showThreadFromSystemMessage(number){var showAction=function act_action(number){var currentLocation=window.location.hash;switch(currentLocation){case'#thread-list':window.location.hash='#num='+number;delete MessageManager.lockActivity;break;case'#new':window.location.hash='#num='+number;delete MessageManager.lockActivity;break;case'#edit':history.back();showAction(number);break;default:if(currentLocation.indexOf('#num=')!=-1){if(currentLocation=='#num='+number){delete MessageManager.lockActivity;}else{MessageManager.activityTarget=number;window.location.hash='#thread-list';}}else{window.location.hash='#num='+number;delete MessageManager.lockActivity;}
break;}};if(!document.documentElement.lang){window.addEventListener('localized',function waitLocalized(){window.removeEventListener('localized',waitLocalized);showAction(number);});}else{if(!document.mozHidden){showAction(number);return;}
document.addEventListener('mozvisibilitychange',function waitVisibility(){document.removeEventListener('mozvisibilitychange',waitVisibility);showAction(number);});}}
window.navigator.mozSetMessageHandler('activity',function actHandle(activity){if(!MessageManager.initialized){MessageManager.init();}
if(MessageManager.lockActivity)
return;MessageManager.lockActivity=true;activity.postResult({status:'accepted'});var number=activity.source.data.number;showThreadFromSystemMessage(number);});if(!window.location.hash.length){window.navigator.mozSetMessageHandler('sms-received',function smsReceived(message){var number=message.sender;if(message.messageClass=='class-0'){navigator.mozApps.getSelf().onsuccess=function(evt){var app=evt.target.result;var iconURL=NotificationHelper.getIconURI(app);iconURL+='?class0';var messageBody=number+'\n'+message.body;var showMessage=function(){app.launch();alert(messageBody);};MessageManager.deleteMessage(message.id,function(){NotificationHelper.send(message.sender,message.body,iconURL,showMessage);});};return;}
if(BlackList.has(message.sender))
return;if(!document.mozHidden){var currentThread=MessageManager.currentNum;if(number==currentThread){navigator.vibrate([200,200,200]);return;}}
navigator.mozApps.getSelf().onsuccess=function(evt){var app=evt.target.result;var iconURL=NotificationHelper.getIconURI(app);iconURL+='?sms-received?'+number;var goToMessage=function(){app.launch();showThreadFromSystemMessage(number);};ContactDataManager.getContactData(message.sender,function gotContact(contact){var sender;if(contact.length&&contact[0].name){sender=contact[0].name;}else{sender=message.sender;}
NotificationHelper.send(sender,message.body,iconURL,goToMessage);});};});window.navigator.mozSetMessageHandler('notification',function notificationClick(message){navigator.mozApps.getSelf().onsuccess=function(evt){var app=evt.target.result;app.launch();var notificationType=message.imageURL.split('?')[1];if(notificationType=='sms-received'){var number=message.imageURL.split('?')[2];showThreadFromSystemMessage(number);return;}
var number=message.title;var messageBody=number+'\n'+message.body;alert(messageBody);};});};'use strict';var _=navigator.mozL10n.get;var dtf=new navigator.mozL10n.DateTimeFormat();var Utils={updateTimeHeaders:function ut_updateTimeHeaders(){var elementsToUpdate=document.querySelectorAll('header[data-time-update]');if(elementsToUpdate.length>0){for(var i=0;i<elementsToUpdate.length;i++){var ts=elementsToUpdate[i].dataset.time;var tmpHeaderDate;if(elementsToUpdate[i].dataset.isThread){tmpHeaderDate=Utils.getHeaderDate(ts);}else{elementsToUpdate[i].dataset.hourOnly?tmpHeaderDate=Utils.getFormattedHour(ts):tmpHeaderDate=Utils.getHeaderDate(ts)+' '+
Utils.getFormattedHour(ts);}
var currentHeader=elementsToUpdate[i].innerHTML;if(tmpHeaderDate!=currentHeader){elementsToUpdate[i].innerHTML=tmpHeaderDate;}}}},startTimeHeaderScheduler:function ut_startTimeHeaderScheduler(){this.updateTimeHeaders();if(this.updateTimer){clearInterval(this.updateTimer);}
this.updateTimer=setInterval(function(self){self.updateTimeHeaders();},50000,this);},escapeHTML:function ut_escapeHTML(str,escapeQuotes){var stringHTML=str;stringHTML=stringHTML.replace(/\</g,'&#60;');stringHTML=stringHTML.replace(/(\r\n|\n|\r)/gm,'<br/>');stringHTML=stringHTML.replace(/\s\s/g,' &nbsp;');if(escapeQuotes)
return stringHTML.replace(/"/g,'&quot;').replace(/'/g,'&#x27;');return stringHTML;},getFormattedHour:function ut_getFormattedHour(time){switch(time.constructor){case String:time=parseInt(time);break;case Date:time=time.getTime();break;}
return dtf.localeFormat(new Date(time),_('shortTimeFormat'));},getDayDate:function re_getDayDate(timestamp){var date=new Date(timestamp);var startDate=new Date(date.getFullYear(),date.getMonth(),date.getDate());return startDate.getTime();},getHeaderDate:function ut_giveHeaderDate(time){switch(time.constructor){case String:time=new Number(time);break;case Date:time=time.getTime();break;}
var today=Utils.getDayDate((new Date()).getTime());var otherDay=Utils.getDayDate(time);var dayDiff=(today-otherDay)/86400000;if(isNaN(dayDiff))
return _('incorrectDate');if(dayDiff<0){return dtf.localeFormat(new Date(time),_('shortDateTimeFormat'));}
return dayDiff==0&&_('today')||dayDiff==1&&_('yesterday')||dayDiff<4&&dtf.localeFormat(new Date(time),'%A')||dtf.localeFormat(new Date(time),'%x');},getFontSize:function ut_getFontSize(){if(!this.rootFontSize){var htmlCss=window.getComputedStyle(document.documentElement,null);this.rootFontSize=parseInt(htmlCss.getPropertyValue('font-size'));}
return this.rootFontSize;},getPhoneDetails:function ut_getPhoneDetails(number,contact,callback){var details={};if(contact){var name=contact.name,phone=contact.tel[0],carrierToShow=phone.carrier;for(var i=0;i<contact.tel.length;i++){var tempPhoneNumber=contact.tel[i].value;if(number.length>7){var rootPhoneNumber=number.substr(-8);}else{var rootPhoneNumber=number;}
if(tempPhoneNumber.indexOf(rootPhoneNumber)!=-1){phone=contact.tel[i];carrierToShow=phone.carrier;break;}}
details.isContact=true;if(contact.photo&&contact.photo[0]){details.photoURL=URL.createObjectURL(contact.photo[0]);}
if(name&&name!=''){for(var i=0;i<contact.tel.length;i++){if(contact.tel[i].value!==phone.value&&contact.tel[i].type==phone.type&&contact.tel[i].carrier==phone.carrier){carrierToShow=phone.value;}}
details.title=name;details.carrier=(carrierToShow||phone.value);}else{details.title=number;details.carrier=(phone.carrier||'');}
if(phone.type){details.carrier=phone.type+' | '+details.carrier;}}else{details.title=number;}
callback(details);}};;'use strict';var SearchUtils={createHighlightHTML:function su_createHighlightHTML(text,regExp,style){var sliceStrs=text.split(regExp);var patterns=text.match(regExp);if(!patterns){return Utils.escapeHTML(text);}
var str='';for(var i=0;i<patterns.length;i++){str=str+
Utils.escapeHTML(sliceStrs[i])+'<span class="'+style+'">'+
Utils.escapeHTML(patterns[i])+'</span>';}
str+=Utils.escapeHTML(sliceStrs.pop());return str;},createNewConversation:function su_createNewConversation(conversation,reg){var dataName=escapeHTML(conversation.name||conversation.num,true);var name=escapeHTML(conversation.name);var bodyText=conversation.body.split('\n')[0];var bodyHTML=this.createHighlightHTML(bodyText,reg);return'<div class="item">'+'  <label class="fake-checkbox">'+'    <input data-num="'+
conversation.num+'"'+'type="checkbox"/>'+'    <span></span>'+'  </label>'+'  <a href="#num='+conversation.num+'"'+'     data-num="'+conversation.num+'"'+'     data-name="'+dataName+'"'+'     data-notempty="'+
(conversation.timestamp?'true':'')+'"'+'     class="'+
(conversation.unreadCount>0?'unread':'')+'">'+'    <span class="unread-mark">'+'      <i class="i-unread-mark"></i>'+'    </span>'+'    <div class="name">'+name+'</div>'+
(!conversation.timestamp?'':'    <div class="time '+
(conversation.unreadCount>0?'unread':'')+'      " data-time="'+conversation.timestamp+'">'+
giveHourMinute(conversation.timestamp)+'    </div>')+'    <div class="msg">"'+bodyHTML+'"</div>'+'    <div class="unread-tag"></div>'+'    <div class="photo"></div>'+'  </a>'+'</div>';},renderResultView:function su_renderResultView(str,view,contactUpdater){if(!str){view.innerHTML='';return;}
var self=this;MessageManager.getMessages(function getMessagesCallback(messages){str=str.replace(/[.*+?^${}()|[\]\/\\]/g,'\\$&');var fragment='';var searchedNum={};for(var i=0;i<messages.length;i++){var reg=new RegExp(str,'ig');var message=messages[i];var htmlContent=message.body.split('\n')[0];var num=message.delivery=='received'?message.sender:message.receiver;var read=message.read;if(searchedNum[num])
searchedNum[num].unreadCount+=!message.read?1:0;if(!reg.test(htmlContent)||searchedNum[num])
continue;var msgProperties={'hidden':false,'body':message.body,'name':num,'num':num,'timestamp':message.timestamp.getTime(),'unreadCount':!read?1:0,'id':i};searchedNum[num]=msgProperties;var msg=self.createNewConversation(msgProperties,reg);fragment+=msg;}
view.innerHTML=fragment;if(contactUpdater){var conversationList=view.querySelectorAll('a');for(var i=0;i<conversationList.length;i++){contactUpdater(conversationList[i]);}}},null);}};;'use strict';var FixedHeader=(function FixedHeader(){var headings;var selector;var view;var fixedContainer;var currentlyFixed;var notApplyEffect;var init=function init(scrollView,container,select,noEffect){selector=select;view=document.querySelector(scrollView);fixedContainer=document.querySelector(container);refresh();view.addEventListener('scroll',scrolling);notApplyEffect=typeof noEffect==='undefined'?false:noEffect;};var refresh=function refresh(){headings=view.querySelectorAll(selector);};var scrolling=function scrolling(){var currentScroll=view.scrollTop;for(var i=headings.length-1;i>=0;i--){var currentHeader=headings[i];var headingPosition=currentHeader.offsetTop-view.offsetTop;var offset=headingPosition-currentScroll;var currentHeight=currentHeader.offsetHeight;var differentHeaders=currentlyFixed!=currentHeader;if(!notApplyEffect&&Math.abs(offset)<currentHeight&&differentHeaders){var toMove=Math.abs(offset)-currentHeight;var inEffect=toMove<=0;var translateTop='translateY('+toMove+'px)';var transform=inEffect?translateTop:null;fixedContainer.style.transform=transform;}
if(offset<=0){if(differentHeaders){if(!notApplyEffect)
fixedContainer.style.transform='translateY(0)';currentlyFixed=currentHeader;fixedContainer.textContent=currentHeader.textContent;if(currentHeader.id=='group-favorites'){fixedContainer.innerHTML=currentHeader.innerHTML;}}
return;}}
currentlyFixed=null;if(!notApplyEffect)
fixedContainer.style.transform='translateY(-100%)';};var stop=function stop(){view.removeEventListener('scroll',scrolling);};var start=function start(){var header=headings[0];if(header){fixedContainer.textContent=header.textContent;}}
return{'init':init,'refresh':refresh,'start':start,'stop':stop};})();;if(!navigator.mozSms){var messagesHack=[],threadsHack=[];(function(){var messages=[{sender:null,receiver:'1977',body:'Alo, how are you today, my friend? :)',delivery:'sent',id:52,read:true,timestamp:new Date(Date.now())},{sender:null,receiver:'1977',body:'arr :)',delivery:'sent',id:511,read:true,timestamp:new Date(Date.now()-8400000000)},{sender:null,receiver:'436797',body:'Sending :)',delivery:'sending',id:51,timestamp:new Date(Date.now()-172800000)},{sender:null,receiver:'197743697',body:'Nothing :)',delivery:'sent',id:48,timestamp:new Date(Date.now()-652800000)},{sender:null,receiver:'197746797',body:'Error message:)',delivery:'sending',error:true,id:47,timestamp:new Date(Date.now()-822800000)},{sender:null,receiver:'197746797',body:'Nothing :)',delivery:'sent',id:46,timestamp:new Date(Date.now()-1002800000)},{sender:null,receiver:'197746797',body:'Nothing :)',delivery:'error',id:460,timestamp:new Date(Date.now()-1002800000)},{sender:'197746797',body:'Recibido!',delivery:'received',id:40,timestamp:new Date(Date.now()-50000000)}];for(var i=0;i<15;i++){messages.push({sender:'14886783487',body:'Hello world!',delivery:'received',id:39-i,timestamp:new Date(Date.now()-60000000)});}
messagesHack=messages;threadsHack=[{senderOrReceiver:'1977',body:'Alo, how are you today, my friend? :)',timestamp:new Date(Date.now()),unreadCount:0},{senderOrReceiver:'436797',body:'Sending :)',timestamp:new Date(Date.now()-172800000),unreadCount:0},{senderOrReceiver:'197743697',body:'Nothing :)',timestamp:new Date(Date.now()-652800000),unreadCount:0},{senderOrReceiver:'197746797',body:'Recibido!',timestamp:new Date(Date.now()-50000000),unreadCount:0},{senderOrReceiver:'14886783487',body:'Hello world!',timestamp:new Date(Date.now()-60000000),unreadCount:2}]})();var GetMessagesHack=function gmhack(callback,filter,invert,cllbckArgs){function applyFilter(msgs){if(!filter)
return msgs;if(filter.numbers){msgs=msgs.filter(function(element,index,array){var num=filter.numbers;return(num&&(num.indexOf(element.sender)!=-1||num.indexOf(element.receiver)!=-1));});}
if(!invert){msgs.sort(function(a,b){return b.timestamp-a.timestamp;});}else{msgs.sort(function(a,b){return a.timestamp-b.timestamp;});}
return msgs;}
messagesHack.sort(function(a,b){return b.timestamp-a.timestamp;});var msg=messagesHack.slice();if(invert)
msg.reverse();callback(applyFilter(msg),cllbckArgs);};MessageManager.getMessages=function(callback,filter,invert,cllbckArgs){GetMessagesHack(callback,filter,invert,cllbckArgs);return;};MessageManager.getThreads=function(callback,extraArg){threadsHack.sort(function(a,b){return a.timestamp-b.timestamp;});callback(threadsHack,extraArg);return;};MessageManager.send=function(number,text,callback){var message={sender:null,receiver:number,delivery:'sent',body:text,id:messagesHack.length,timestamp:new Date()};var simulateFail=/fail/i.test(text);window.setTimeout(function sent(){if(simulateFail){callback(null);return;}
callback(message);window.setTimeout(function writeDB(){messagesHack.unshift(message);},90*Math.random());},3000*Math.random());if(simulateFail)
return;window.setTimeout(function hiBack(){var message={sender:number,receiver:null,delivery:'received',body:'Hi back! '+text,id:messagesHack.length,timestamp:new Date()};var evt={type:'received',message:message};MessageManager.handleEvent.call(MessageManager,evt);window.setTimeout(function writeDB(){messagesHack.unshift(message);},90*Math.random());},5000+3000*Math.random());};}